searchData={"items":[{"type":"behaviour","title":"EAGL.WindowBehaviour","doc":"Behaviour for OpenGL window management.\nHandles window creation, OpenGL context setup, and event loop management.","ref":"EAGL.WindowBehaviour.html"},{"type":"callback","title":"EAGL.WindowBehaviour.cleanup/1","doc":"Called when the window is being closed.\nShould clean up resources in state.","ref":"EAGL.WindowBehaviour.html#c:cleanup/1"},{"type":"callback","title":"EAGL.WindowBehaviour.handle_event/2","doc":"Called when an event occurs (keyboard, mouse, etc.).\nThis callback is optional. If not implemented, events are ignored.\nShould return {:ok, new_state} to continue with updated state.","ref":"EAGL.WindowBehaviour.html#c:handle_event/2"},{"type":"callback","title":"EAGL.WindowBehaviour.render/3","doc":"Called when the window needs to be rendered.\nThe OpenGL context is already current and the viewport is set.","ref":"EAGL.WindowBehaviour.html#c:render/3"},{"type":"callback","title":"EAGL.WindowBehaviour.setup/0","doc":"Called when the OpenGL context is ready and shaders should be created.\nShould return {:ok, state} or {:error, reason}","ref":"EAGL.WindowBehaviour.html#c:setup/0"},{"type":"task","title":"mix eagl.test","doc":"Runs EAGL tests excluding interactive examples that require user input.\n\nThis prevents tests from hanging while waiting for ENTER key presses.","ref":"Mix.Tasks.Eagl.Test.html"},{"type":"task","title":"Examples - mix eagl.test","doc":"mix eagl.test\n    mix eagl.test --verbose","ref":"Mix.Tasks.Eagl.Test.html#module-examples"},{"type":"function","title":"Mix.Tasks.Eagl.Test.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Eagl.Test.html#run/1"},{"type":"module","title":"WX.Const","doc":"wxWidgets constants for GUI and OpenGL canvas management.\nUse this module to inject wxWidgets constants as module attributes.","ref":"WX.Const.html"},{"type":"module","title":"Usage - WX.Const","doc":"defmodule MyModule do\n      use WX.Const\n\n      # Now you can use @wx_vertical, @wx_gl_rgba, @wx_expand, etc.\n    end","ref":"WX.Const.html#module-usage"},{"type":"module","title":"Categories - WX.Const","doc":"This module provides constants for:\n- OpenGL canvas attributes (WX_GL_*)\n- Layout directions and sizer flags\n- Window styles and background styles\n- Event types and window management","ref":"WX.Const.html#module-categories"},{"type":"module","title":"EAGL.Buffer","doc":"Helper functions for OpenGL buffer and vertex array object management.\nProvides convenient wrappers for common VAO/VBO/EBO operations.","ref":"EAGL.Buffer.html"},{"type":"function","title":"EAGL.Buffer.create_indexed_array/3","doc":"Creates a VAO with VBO and EBO for indexed geometry.\nReturns {vao, vbo, ebo} tuple.","ref":"EAGL.Buffer.html#create_indexed_array/3"},{"type":"function","title":"Parameters - EAGL.Buffer.create_indexed_array/3","doc":"- vertices: List of floats representing vertex data\n- indices: List of integers representing vertex indices\n- attribute_configs: List of attribute configurations\n  Each config is {location, size, type, normalized, stride, offset}","ref":"EAGL.Buffer.html#create_indexed_array/3-parameters"},{"type":"function","title":"Example - EAGL.Buffer.create_indexed_array/3","doc":"vertices = [0.5, 0.5, 0.0, 0.5, -0.5, 0.0, -0.5, -0.5, 0.0, -0.5, 0.5, 0.0]\n    indices = [0, 1, 3, 1, 2, 3]\n    {vao, vbo, ebo} = create_indexed_array(vertices, indices, [{0, 3, @gl_float, @gl_false, 0, 0}])","ref":"EAGL.Buffer.html#create_indexed_array/3-example"},{"type":"function","title":"EAGL.Buffer.create_indexed_position_array/2","doc":"Creates a simple indexed VAO with position-only vertices (3 floats per vertex).\nConvenience wrapper for indexed geometry with positions only.","ref":"EAGL.Buffer.html#create_indexed_position_array/2"},{"type":"function","title":"Example - EAGL.Buffer.create_indexed_position_array/2","doc":"vertices = [0.5, 0.5, 0.0, 0.5, -0.5, 0.0, -0.5, -0.5, 0.0, -0.5, 0.5, 0.0]\n    indices = [0, 1, 3, 1, 2, 3]  # Two triangles forming a rectangle\n    {vao, vbo, ebo} = create_indexed_position_array(vertices, indices)","ref":"EAGL.Buffer.html#create_indexed_position_array/2-example"},{"type":"function","title":"EAGL.Buffer.create_position_array/1","doc":"Creates a simple VAO with position-only vertices (3 floats per vertex).\nConvenience wrapper for the most common case.","ref":"EAGL.Buffer.html#create_position_array/1"},{"type":"function","title":"Example - EAGL.Buffer.create_position_array/1","doc":"vertices = [-0.5, -0.5, 0.0, 0.5, -0.5, 0.0, 0.0, 0.5, 0.0]\n    {vao, vbo} = create_position_array(vertices)","ref":"EAGL.Buffer.html#create_position_array/1-example"},{"type":"function","title":"EAGL.Buffer.create_vertex_array/2","doc":"Creates a VAO with a single VBO containing vertex data.\nReturns {vao, vbo} tuple.","ref":"EAGL.Buffer.html#create_vertex_array/2"},{"type":"function","title":"Parameters - EAGL.Buffer.create_vertex_array/2","doc":"- vertices: List of floats representing vertex data\n- attribute_configs: List of attribute configurations\n  Each config is {location, size, type, normalized, stride, offset}","ref":"EAGL.Buffer.html#create_vertex_array/2-parameters"},{"type":"function","title":"Example - EAGL.Buffer.create_vertex_array/2","doc":"vertices = [-0.5, -0.5, 0.0, 0.5, -0.5, 0.0, 0.0, 0.5, 0.0]\n    {vao, vbo} = create_vertex_array(vertices, [{0, 3, @gl_float, @gl_false, 0, 0}])","ref":"EAGL.Buffer.html#create_vertex_array/2-example"},{"type":"function","title":"EAGL.Buffer.delete_indexed_array/3","doc":"Deletes a VAO and its associated VBO and EBO.","ref":"EAGL.Buffer.html#delete_indexed_array/3"},{"type":"function","title":"EAGL.Buffer.delete_vertex_array/2","doc":"Deletes a VAO and its associated VBOs.","ref":"EAGL.Buffer.html#delete_vertex_array/2"},{"type":"function","title":"EAGL.Buffer.indices_to_binary/1","doc":"Converts a list of indices to binary format for OpenGL.","ref":"EAGL.Buffer.html#indices_to_binary/1"},{"type":"function","title":"EAGL.Buffer.vertices_to_binary/1","doc":"Converts a list of vertex floats to binary format for OpenGL.","ref":"EAGL.Buffer.html#vertices_to_binary/1"},{"type":"module","title":"EAGL.Error","doc":"OpenGL error handling utilities.\nProvides functions for checking and reporting OpenGL errors.","ref":"EAGL.Error.html"},{"type":"function","title":"EAGL.Error.check/1","doc":"Check for OpenGL errors and print them.\nSimilar to Wings3D's check_error/2 function.","ref":"EAGL.Error.html#check/1"},{"type":"function","title":"Parameters - EAGL.Error.check/1","doc":"- context: String describing the context where the error check is performed","ref":"EAGL.Error.html#check/1-parameters"},{"type":"function","title":"Returns - EAGL.Error.check/1","doc":"- `:ok` if no error\n- `{:error, error_message}` if an error occurred","ref":"EAGL.Error.html#check/1-returns"},{"type":"function","title":"Example - EAGL.Error.check/1","doc":"EAGL.Error.check(\"After buffer creation\")\n    EAGL.Error.check(\"Shader compilation\")","ref":"EAGL.Error.html#check/1-example"},{"type":"function","title":"EAGL.Error.check!/1","doc":"Check for OpenGL errors and raise an exception if one is found.\nUseful for development and debugging.","ref":"EAGL.Error.html#check!/1"},{"type":"function","title":"EAGL.Error.error_string/1","doc":"Get a human-readable string for an OpenGL error code.\nSimilar to Wings3D's error_string/1 function.","ref":"EAGL.Error.html#error_string/1"},{"type":"module","title":"EAGL.Math","doc":"Port of the OpenGL GLM header files to Elixir.\nNote that Erlang wx OpenGL represents matricies and vectors as\nflat tuples nested in lists.","ref":"EAGL.Math.html"},{"type":"function","title":"EAGL.Math.abs_val/1","doc":"Absolute value.","ref":"EAGL.Math.html#abs_val/1"},{"type":"function","title":"EAGL.Math.angle_between/2","doc":"Calculate angle between two vectors in radians.","ref":"EAGL.Math.html#angle_between/2"},{"type":"function","title":"EAGL.Math.clamp/3","doc":"Clamp value between min and max.","ref":"EAGL.Math.html#clamp/3"},{"type":"function","title":"EAGL.Math.cross/2","doc":"Compute the cross product of two 3D vectors.","ref":"EAGL.Math.html#cross/2"},{"type":"function","title":"EAGL.Math.degrees/1","doc":"Convert radians to degrees.","ref":"EAGL.Math.html#degrees/1"},{"type":"function","title":"EAGL.Math.distance/2","doc":"Calculate the distance between two points (vectors).","ref":"EAGL.Math.html#distance/2"},{"type":"function","title":"EAGL.Math.distance_squared/2","doc":"Calculate the squared distance between two points (avoids sqrt).","ref":"EAGL.Math.html#distance_squared/2"},{"type":"function","title":"EAGL.Math.dot/2","doc":"Compute the dot product of two vectors (2D, 3D, or 4D).","ref":"EAGL.Math.html#dot/2"},{"type":"function","title":"EAGL.Math.face_normal/3","doc":"Calculate face normal from three vertices (assumes counter-clockwise winding).","ref":"EAGL.Math.html#face_normal/3"},{"type":"function","title":"EAGL.Math.fract/1","doc":"Fractional part of x (x - floor(x)).","ref":"EAGL.Math.html#fract/1"},{"type":"function","title":"EAGL.Math.inverse_sqrt/1","doc":"Fast inverse square root approximation.","ref":"EAGL.Math.html#inverse_sqrt/1"},{"type":"function","title":"EAGL.Math.length_squared/1","doc":"Compute the squared length of a vector (avoids sqrt for performance).","ref":"EAGL.Math.html#length_squared/1"},{"type":"function","title":"EAGL.Math.lerp/3","doc":"Linear interpolation between two values.","ref":"EAGL.Math.html#lerp/3"},{"type":"type","title":"EAGL.Math.mat2/0","doc":"","ref":"EAGL.Math.html#t:mat2/0"},{"type":"function","title":"EAGL.Math.mat2/4","doc":"Create a 2x2 matrix.","ref":"EAGL.Math.html#mat2/4"},{"type":"function","title":"EAGL.Math.mat2_identity/0","doc":"Create a 2x2 identity matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat2_identity/0"},{"type":"type","title":"EAGL.Math.mat3/0","doc":"","ref":"EAGL.Math.html#t:mat3/0"},{"type":"function","title":"EAGL.Math.mat3/9","doc":"Create a 3x3 matrix.","ref":"EAGL.Math.html#mat3/9"},{"type":"function","title":"EAGL.Math.mat3_identity/0","doc":"Create a 3x3 identity matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat3_identity/0"},{"type":"function","title":"EAGL.Math.mat3_mul/2","doc":"Multiply two 3x3 matrices.\nAll matrices are in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat3_mul/2"},{"type":"function","title":"EAGL.Math.mat3_transpose/1","doc":"Transpose a 3x3 matrix.\nInput and output matrices are in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat3_transpose/1"},{"type":"type","title":"EAGL.Math.mat4/0","doc":"","ref":"EAGL.Math.html#t:mat4/0"},{"type":"function","title":"EAGL.Math.mat4/16","doc":"Create a 4x4 matrix.","ref":"EAGL.Math.html#mat4/16"},{"type":"function","title":"EAGL.Math.mat4_identity/0","doc":"Create a 4x4 identity matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_identity/0"},{"type":"function","title":"EAGL.Math.mat4_inverse/1","doc":"Create the inverse of a 4x4 matrix using the adjugate method.\nReturns the original matrix if it's not invertible (determinant is zero).\nInput and output matrices are in column-major order for OpenGL compatibility.\nNote this is the only function not from the original OpenGl GLM library.","ref":"EAGL.Math.html#mat4_inverse/1"},{"type":"function","title":"EAGL.Math.mat4_look_at/3","doc":"Create a look-at view matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_look_at/3"},{"type":"function","title":"EAGL.Math.mat4_mul/2","doc":"Multiply two 4x4 matrices.\nAll matrices are in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_mul/2"},{"type":"function","title":"EAGL.Math.mat4_ortho/6","doc":"Create an orthographic projection matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_ortho/6"},{"type":"function","title":"EAGL.Math.mat4_perspective/4","doc":"Create a perspective projection matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_perspective/4"},{"type":"function","title":"EAGL.Math.mat4_rotate/2","doc":"Create a rotation matrix from axis and angle.","ref":"EAGL.Math.html#mat4_rotate/2"},{"type":"function","title":"EAGL.Math.mat4_rotate_x/1","doc":"Create a rotation matrix around the X axis.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_rotate_x/1"},{"type":"function","title":"EAGL.Math.mat4_rotate_y/1","doc":"Create a rotation matrix around the Y axis.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_rotate_y/1"},{"type":"function","title":"EAGL.Math.mat4_rotate_z/1","doc":"Create a rotation matrix around the Z axis.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_rotate_z/1"},{"type":"function","title":"EAGL.Math.mat4_scale/1","doc":"Create a scale matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_scale/1"},{"type":"function","title":"EAGL.Math.mat4_transform_point/2","doc":"Multiply a 3D vector by a 4x4 matrix (treating vector as point with w=1).\nReturns a 3D vector with the w component divided out.","ref":"EAGL.Math.html#mat4_transform_point/2"},{"type":"function","title":"EAGL.Math.mat4_transform_vec4/2","doc":"Multiply a 4D vector by a 4x4 matrix.","ref":"EAGL.Math.html#mat4_transform_vec4/2"},{"type":"function","title":"EAGL.Math.mat4_transform_vector/2","doc":"Multiply a 3D vector by a 4x4 matrix (treating vector as direction with w=0).\nUsed for transforming direction vectors (normals, etc.) where translation should be ignored.","ref":"EAGL.Math.html#mat4_transform_vector/2"},{"type":"function","title":"EAGL.Math.mat4_translate/1","doc":"Create a translation matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_translate/1"},{"type":"function","title":"EAGL.Math.mat4_transpose/1","doc":"Transpose a 4x4 matrix.\nInput and output matrices are in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_transpose/1"},{"type":"function","title":"EAGL.Math.mix/3","doc":"Mix (linear interpolation) between two values.","ref":"EAGL.Math.html#mix/3"},{"type":"function","title":"EAGL.Math.mod/2","doc":"Modulo operation that works with floats.","ref":"EAGL.Math.html#mod/2"},{"type":"function","title":"EAGL.Math.normalize/1","doc":"Normalize a vector to unit length (2D, 3D, or 4D).","ref":"EAGL.Math.html#normalize/1"},{"type":"function","title":"EAGL.Math.parallel?/3","doc":"Check if two vectors are parallel (dot product close to ±1).","ref":"EAGL.Math.html#parallel?/3"},{"type":"function","title":"EAGL.Math.perpendicular?/3","doc":"Check if two vectors are perpendicular (dot product close to 0).","ref":"EAGL.Math.html#perpendicular?/3"},{"type":"function","title":"EAGL.Math.project/2","doc":"Project vector a onto vector b.","ref":"EAGL.Math.html#project/2"},{"type":"type","title":"EAGL.Math.quat/0","doc":"","ref":"EAGL.Math.html#t:quat/0"},{"type":"function","title":"EAGL.Math.quat/4","doc":"Create a quaternion.\nQuaternions are represented as {x, y, z, w} where w is the scalar component.\nThis follows the (x, y, z, w) convention commonly used in graphics programming.","ref":"EAGL.Math.html#quat/4"},{"type":"function","title":"EAGL.Math.quat_conjugate/1","doc":"Conjugate a quaternion (negate x, y, z components).","ref":"EAGL.Math.html#quat_conjugate/1"},{"type":"function","title":"EAGL.Math.quat_from_axis_angle/2","doc":"Create a quaternion from axis-angle representation.","ref":"EAGL.Math.html#quat_from_axis_angle/2"},{"type":"function","title":"EAGL.Math.quat_from_euler/3","doc":"Create a quaternion from Euler angles (pitch, yaw, roll in radians).","ref":"EAGL.Math.html#quat_from_euler/3"},{"type":"function","title":"EAGL.Math.quat_identity/0","doc":"Create an identity quaternion (no rotation).","ref":"EAGL.Math.html#quat_identity/0"},{"type":"function","title":"EAGL.Math.quat_mul/2","doc":"Multiply two quaternions.","ref":"EAGL.Math.html#quat_mul/2"},{"type":"function","title":"EAGL.Math.quat_normalize/1","doc":"Normalize a quaternion.","ref":"EAGL.Math.html#quat_normalize/1"},{"type":"function","title":"EAGL.Math.quat_rotate_vec3/2","doc":"Rotate a 3D vector by a quaternion.","ref":"EAGL.Math.html#quat_rotate_vec3/2"},{"type":"function","title":"EAGL.Math.quat_slerp/3","doc":"Spherical linear interpolation between two quaternions.","ref":"EAGL.Math.html#quat_slerp/3"},{"type":"function","title":"EAGL.Math.quat_to_mat3/1","doc":"Convert quaternion to rotation matrix (3x3).\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#quat_to_mat3/1"},{"type":"function","title":"EAGL.Math.quat_to_mat4/1","doc":"Convert quaternion to rotation matrix (4x4).\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#quat_to_mat4/1"},{"type":"function","title":"EAGL.Math.radians/1","doc":"Convert degrees to radians.","ref":"EAGL.Math.html#radians/1"},{"type":"function","title":"EAGL.Math.reflect/2","doc":"Reflect a vector around a normal.","ref":"EAGL.Math.html#reflect/2"},{"type":"function","title":"EAGL.Math.refract/3","doc":"Refract a vector around a normal with given refractive index ratio.","ref":"EAGL.Math.html#refract/3"},{"type":"function","title":"EAGL.Math.reject/2","doc":"Reject vector a from vector b (perpendicular component).","ref":"EAGL.Math.html#reject/2"},{"type":"function","title":"EAGL.Math.sign/1","doc":"Sign function (-1, 0, or 1).","ref":"EAGL.Math.html#sign/1"},{"type":"function","title":"EAGL.Math.smooth_step/3","doc":"Smooth step function (Hermite interpolation).","ref":"EAGL.Math.html#smooth_step/3"},{"type":"function","title":"EAGL.Math.step/2","doc":"Step function (returns 0.0 if x < edge, 1.0 otherwise).","ref":"EAGL.Math.html#step/2"},{"type":"type","title":"EAGL.Math.vec2/0","doc":"","ref":"EAGL.Math.html#t:vec2/0"},{"type":"function","title":"EAGL.Math.vec2/2","doc":"Create a 2D vector.","ref":"EAGL.Math.html#vec2/2"},{"type":"function","title":"EAGL.Math.vec2_zero/0","doc":"Create a zero vector (2D).","ref":"EAGL.Math.html#vec2_zero/0"},{"type":"type","title":"EAGL.Math.vec3/0","doc":"","ref":"EAGL.Math.html#t:vec3/0"},{"type":"function","title":"EAGL.Math.vec3/3","doc":"Create a 3D vector.","ref":"EAGL.Math.html#vec3/3"},{"type":"function","title":"EAGL.Math.vec3_one/0","doc":"Create a 3D vector with all components set to 1.","ref":"EAGL.Math.html#vec3_one/0"},{"type":"function","title":"EAGL.Math.vec3_unit_x/0","doc":"Create the X unit vector (1, 0, 0).","ref":"EAGL.Math.html#vec3_unit_x/0"},{"type":"function","title":"EAGL.Math.vec3_unit_y/0","doc":"Create the Y unit vector (0, 1, 0).","ref":"EAGL.Math.html#vec3_unit_y/0"},{"type":"function","title":"EAGL.Math.vec3_unit_z/0","doc":"Create the Z unit vector (0, 0, 1).","ref":"EAGL.Math.html#vec3_unit_z/0"},{"type":"function","title":"EAGL.Math.vec3_zero/0","doc":"Create a zero vector (3D).","ref":"EAGL.Math.html#vec3_zero/0"},{"type":"type","title":"EAGL.Math.vec4/0","doc":"","ref":"EAGL.Math.html#t:vec4/0"},{"type":"function","title":"EAGL.Math.vec4/4","doc":"Create a 4D vector.","ref":"EAGL.Math.html#vec4/4"},{"type":"function","title":"EAGL.Math.vec4_zero/0","doc":"Create a zero vector (4D).","ref":"EAGL.Math.html#vec4_zero/0"},{"type":"function","title":"EAGL.Math.vec_add/2","doc":"Add two vectors component-wise.","ref":"EAGL.Math.html#vec_add/2"},{"type":"function","title":"EAGL.Math.vec_length/1","doc":"Compute the length (magnitude) of a vector (2D, 3D, or 4D).","ref":"EAGL.Math.html#vec_length/1"},{"type":"function","title":"EAGL.Math.vec_lerp/3","doc":"Linear interpolation between two vectors.","ref":"EAGL.Math.html#vec_lerp/3"},{"type":"function","title":"EAGL.Math.vec_negate/1","doc":"Negate a vector (multiply by -1).","ref":"EAGL.Math.html#vec_negate/1"},{"type":"function","title":"EAGL.Math.vec_scale/2","doc":"Multiply a vector by a scalar.","ref":"EAGL.Math.html#vec_scale/2"},{"type":"function","title":"EAGL.Math.vec_sub/2","doc":"Subtract two vectors component-wise.","ref":"EAGL.Math.html#vec_sub/2"},{"type":"module","title":"EAGL.Shader","doc":"Module for OpenGL shader management.\nHandles shader creation, compilation, and program linking.","ref":"EAGL.Shader.html"},{"type":"function","title":"EAGL.Shader.cache_uniform_locations/2","doc":"Convenience function to cache uniform locations for repeated use.\nReturns a map of uniform names to their locations.","ref":"EAGL.Shader.html#cache_uniform_locations/2"},{"type":"function","title":"EAGL.Shader.check_compile_status/1","doc":"Checks if a shader compiled successfully.","ref":"EAGL.Shader.html#check_compile_status/1"},{"type":"function","title":"EAGL.Shader.check_link_status/1","doc":"","ref":"EAGL.Shader.html#check_link_status/1"},{"type":"function","title":"EAGL.Shader.cleanup_program/1","doc":"Cleans up a shader program and all its attached shaders.","ref":"EAGL.Shader.html#cleanup_program/1"},{"type":"function","title":"EAGL.Shader.cleanup_shader/1","doc":"Cleans up a shader.","ref":"EAGL.Shader.html#cleanup_shader/1"},{"type":"function","title":"EAGL.Shader.create_attach_link/1","doc":"Creates a program, attaches shaders, links, and returns the link status.","ref":"EAGL.Shader.html#create_attach_link/1"},{"type":"function","title":"EAGL.Shader.create_shader/2","doc":"Creates and compiles a shader of the specified type with the given source code.\nReturns the shader ID.","ref":"EAGL.Shader.html#create_shader/2"},{"type":"function","title":"EAGL.Shader.get_uniform_location/2","doc":"Get uniform location for a program. Similar to wings_gl:uloc/2.\nReturns the uniform location or -1 if not found.","ref":"EAGL.Shader.html#get_uniform_location/2"},{"type":"type","title":"EAGL.Shader.mat2/0","doc":"","ref":"EAGL.Shader.html#t:mat2/0"},{"type":"type","title":"EAGL.Shader.mat3/0","doc":"","ref":"EAGL.Shader.html#t:mat3/0"},{"type":"type","title":"EAGL.Shader.mat4/0","doc":"","ref":"EAGL.Shader.html#t:mat4/0"},{"type":"type","title":"EAGL.Shader.quat/0","doc":"","ref":"EAGL.Shader.html#t:quat/0"},{"type":"function","title":"EAGL.Shader.set_uniform/3","doc":"Set uniform value with automatic type detection. Similar to wings_gl:set_uloc/3.\nSupports various EAGL.Math types and basic values.","ref":"EAGL.Shader.html#set_uniform/3"},{"type":"function","title":"EAGL.Shader.set_uniform_at_location/2","doc":"Set uniform value at a specific location with automatic type detection.","ref":"EAGL.Shader.html#set_uniform_at_location/2"},{"type":"function","title":"EAGL.Shader.set_uniforms/2","doc":"Convenience function to set multiple uniforms at once.\nTakes a program and a keyword list of uniform_name -> value pairs.","ref":"EAGL.Shader.html#set_uniforms/2"},{"type":"type","title":"EAGL.Shader.uniform_value/0","doc":"","ref":"EAGL.Shader.html#t:uniform_value/0"},{"type":"type","title":"EAGL.Shader.vec2/0","doc":"","ref":"EAGL.Shader.html#t:vec2/0"},{"type":"type","title":"EAGL.Shader.vec3/0","doc":"","ref":"EAGL.Shader.html#t:vec3/0"},{"type":"type","title":"EAGL.Shader.vec4/0","doc":"","ref":"EAGL.Shader.html#t:vec4/0"},{"type":"module","title":"EAGL.Window","doc":"Utility module for OpenGL window management.\nHandles window creation, OpenGL context setup, and event loop management.","ref":"EAGL.Window.html"},{"type":"function","title":"EAGL.Window.run/2","doc":"Creates and runs an OpenGL window using the given callback module.\nThe callback module must implement the GLWindowBehaviour.\n\nOptions:\n- size: {width, height} tuple, defaults to {1024, 768}. Sets the initial window size.\n- depth_testing: boolean, defaults to false. When true, enables depth testing and requests a depth buffer.\n- return_to_exit: boolean, defaults to false. When true, pressing ENTER will automatically close the window.","ref":"EAGL.Window.html#run/2"},{"type":"function","title":"EAGL.Window.run/3","doc":"","ref":"EAGL.Window.html#run/3"},{"type":"module","title":"EAGL.Model","doc":"Helper module for loading 3D model resources and creating OpenGL vertex array objects.","ref":"EAGL.Model.html"},{"type":"function","title":"EAGL.Model.delete_vao/1","doc":"Deletes a vertex array object and its associated buffers.","ref":"EAGL.Model.html#delete_vao/1"},{"type":"function","title":"EAGL.Model.list_models/0","doc":"Lists all available models in the priv/models directory.","ref":"EAGL.Model.html#list_models/0"},{"type":"function","title":"EAGL.Model.load_model/2","doc":"Loads a model from the priv/models directory.\nReturns the processed model data ready for OpenGL.\n\nOptions:\n  - :flip_normal_direction - boolean, set to true to flip normal direction for all models (default: false)\n                             This works for both models with existing normals and models that need generated normals.\n  - :smooth_normals - boolean, set to true to generate smooth normals by averaging across adjacent faces (default: false)\n                      This gives a smoother appearance by eliminating the faceted look.","ref":"EAGL.Model.html#load_model/2"},{"type":"function","title":"EAGL.Model.load_model_to_vao/2","doc":"Loads a model and creates a VAO with the model data.\nReturns {:ok, %{vao: vao, vertex_count: count}} or {:error, reason}\n\nThe VAO will have the following attributes:\n- Location 0: Vertex positions (vec3)\n- Location 1: Texture coordinates (vec2)\n- Location 2: Normals (vec3)\n\nOptions:\n  - :flip_normal_direction - boolean, set to true to flip normal direction for all models (default: false)\n                             This works for both models with existing normals and models that need generated normals.\n                             Useful when model normals are pointing in the wrong direction for your lighting setup.\n  - :smooth_normals - boolean, set to true to generate smooth normals by averaging across adjacent faces (default: false)\n                      This gives a smoother appearance by eliminating the faceted look.\n                      When true, existing normals are ignored and smooth normals are generated.","ref":"EAGL.Model.html#load_model_to_vao/2"},{"type":"module","title":"EAGL.ObjLoader","doc":"Simple Wavefront OBJ file loader.\nCurrently supports vertices, texture coordinates, normals, and faces.","ref":"EAGL.ObjLoader.html"},{"type":"function","title":"EAGL.ObjLoader.load_obj/2","doc":"Loads an OBJ file and returns vertex data ready for OpenGL.\nReturns {:ok, data} where data is a map containing:\n  - :vertices - List of floats in x,y,z order\n  - :tex_coords - List of floats in u,v order\n  - :normals - List of floats in x,y,z order\n  - :indices - List of integers for indexed drawing\n\nOptions:\n  - :flip_normal_direction - boolean, set to true to flip normal direction for all models (default: false)\n                             This works consistently for both models with existing normals and models that need generated normals.\n                             For models with existing normals: negates all normal components\n                             For models without normals: generates normals with flipped direction\n  - :smooth_normals - boolean, set to true to generate smooth normals by averaging across adjacent faces (default: false)\n                      This gives a smoother appearance by eliminating the faceted look.\n                      When true, existing normals are ignored and smooth normals are generated.","ref":"EAGL.ObjLoader.html#load_obj/2"},{"type":"module","title":"EAGL.Const","doc":"Curated set of 300 OpenGL constants for 3D graphics programming. Additional constants\ncan be added as needed from the 4,925 constants in the wx/include/gl.hrl file.\n\nUse this module to inject OpenGL constants as module attributes.","ref":"EAGL.Const.html"},{"type":"module","title":"Usage - EAGL.Const","doc":"defmodule MyModule do\n      use EAGL.Const\n\n      # Now you can use @gl_vertex_shader, @gl_triangles, @gl_texture_2d, etc.\n    end","ref":"EAGL.Const.html#module-usage"},{"type":"module","title":"Categories - EAGL.Const","doc":"This module provides constants for:\n- Shader types and compilation\n- Buffer types and usage patterns\n- Drawing primitives and polygon modes\n- Data types and formats\n- Textures and sampling\n- Blending and transparency\n- Depth and stencil testing\n- Matrices and transformations\n- Vertex attributes and arrays\n- Framebuffers and attachments\n- And much more...","ref":"EAGL.Const.html#module-categories"},{"type":"module","title":"EAGL.Examples.Math","doc":"Comprehensive example demonstrating all EAGL.Math functionality.\nThis showcases vector and quaternion constructor macros, vector operations,\nquaternions, matrices, utility functions, and real-world OpenGL usage patterns.","ref":"EAGL.Examples.Math.html"},{"type":"function","title":"EAGL.Examples.Math.constructor_examples/0","doc":"Example showing various vector and quaternion constructors.","ref":"EAGL.Examples.Math.html#constructor_examples/0"},{"type":"function","title":"EAGL.Examples.Math.lighting_demo/0","doc":"Demonstrate lighting calculations using vectors.","ref":"EAGL.Examples.Math.html#lighting_demo/0"},{"type":"function","title":"EAGL.Examples.Math.matrix_operations_demo/0","doc":"Demonstrate matrix operations.","ref":"EAGL.Examples.Math.html#matrix_operations_demo/0"},{"type":"function","title":"EAGL.Examples.Math.opengl_usage_examples/0","doc":"Example showing how to use these in an OpenGL context.","ref":"EAGL.Examples.Math.html#opengl_usage_examples/0"},{"type":"function","title":"EAGL.Examples.Math.quaternion_operations_demo/0","doc":"Demonstrate quaternion operations.","ref":"EAGL.Examples.Math.html#quaternion_operations_demo/0"},{"type":"function","title":"EAGL.Examples.Math.run_example/0","doc":"Run the math example - consistent interface with other examples.","ref":"EAGL.Examples.Math.html#run_example/0"},{"type":"function","title":"EAGL.Examples.Math.transformation_pipeline_demo/0","doc":"Demonstrate typical OpenGL transformation pipeline.","ref":"EAGL.Examples.Math.html#transformation_pipeline_demo/0"},{"type":"function","title":"EAGL.Examples.Math.utility_functions_demo/0","doc":"Demonstrate utility and trigonometric functions.","ref":"EAGL.Examples.Math.html#utility_functions_demo/0"},{"type":"function","title":"EAGL.Examples.Math.vector_operations_demo/0","doc":"Demonstrate vector operations.","ref":"EAGL.Examples.Math.html#vector_operations_demo/0"},{"type":"module","title":"EAGL.Examples.Teapot","doc":"Draw a 3D teapot with Phong shading.\nPress ENTER to quit","ref":"EAGL.Examples.Teapot.html"},{"type":"function","title":"EAGL.Examples.Teapot.run_example/0","doc":"","ref":"EAGL.Examples.Teapot.html#run_example/0"},{"type":"module","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle","doc":"LearnOpenGL 2.1 - Hello Triangle\n\nThis example demonstrates your first triangle in OpenGL - the foundation of all 3D graphics.\nIt corresponds to the Hello Triangle tutorial in the LearnOpenGL series.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle.html"},{"type":"module","title":"Original C++ Source - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle","doc":"This example is based on the original LearnOpenGL C++ tutorial:","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle.html#module-original-c-source"},{"type":"module","title":"Framework Adaptation Notes - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle","doc":"In the original LearnOpenGL C++ tutorial, this example introduces the core OpenGL rendering pipeline:\nvertex data → vertex shader → primitive assembly → fragment shader → framebuffer.\n\nEAGL's framework simplifies the setup while preserving all educational concepts:\n- Shader compilation and linking are handled by EAGL.Shader helpers\n- VAO/VBO creation uses EAGL.Buffer convenience functions\n- Error checking and resource cleanup are automated\n- The core OpenGL concepts remain unchanged and visible","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle.html#module-framework-adaptation-notes"},{"type":"module","title":"Original Tutorial Concepts Demonstrated - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle","doc":"1. **Vertex Data**: Defining triangle vertices in normalized device coordinates (-1 to 1)\n2. **Vertex Buffer Objects (VBO)**: Storing vertex data in GPU memory\n3. **Vertex Array Objects (VAO)**: Configuring how vertex data is interpreted\n4. **Vertex Shaders**: Processing each vertex (position transformation)\n5. **Fragment Shaders**: Determining pixel colors\n6. **Rendering Pipeline**: glDrawArrays() triggers the complete pipeline","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle.html#module-original-tutorial-concepts-demonstrated"},{"type":"module","title":"Key Learning Points - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle","doc":"- Understanding normalized device coordinates (NDC)\n- The relationship between VBOs and VAOs\n- How shaders process vertices and fragments\n- The OpenGL rendering pipeline flow\n- Basic primitive rendering with glDrawArrays","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle.html#module-key-learning-points"},{"type":"module","title":"Triangle Geometry - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle","doc":"The triangle is defined by 3 vertices in normalized device coordinates:\n```\n    (0.0, 0.5)\n       /\\\n      /  \\\n     /    \\\n    /______\\\n(-0.5,-0.5) (0.5,-0.5)\n```","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle.html#module-triangle-geometry"},{"type":"module","title":"Difference from Previous Examples - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle","doc":"- **1.1 Hello Window**: Just a black window (no geometry)\n- **1.2 Hello Window Clear**: Custom clear color (no geometry)\n- **2.1 Hello Triangle**: First actual geometry rendering with shaders","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle.html#module-difference-from-previous-examples"},{"type":"module","title":"Usage - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle","doc":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle.run_example()\n\nPress ENTER to exit the example.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle.html#module-usage"},{"type":"function","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle.run_example/0","doc":"","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangle.html#run_example/0"},{"type":"module","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1","doc":"LearnOpenGL 2.3 - Hello Triangle Exercise 1 (Two Triangles Side by Side)\n\nThis example demonstrates drawing multiple triangles with a single draw call.\nIt solves the first exercise from the Hello Triangle tutorial.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.html"},{"type":"module","title":"Original C++ Source - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1","doc":"This example is based on the original LearnOpenGL C++ tutorial:","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.html#module-original-c-source"},{"type":"module","title":"Framework Adaptation Notes - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1","doc":"In the original LearnOpenGL C++ tutorial, this exercise asks you to draw 2 triangles\nnext to each other using glDrawArrays by adding more vertices to your data.\n\nEAGL's framework maintains the same approach:\n- Single VAO/VBO containing all vertex data\n- One glDrawArrays call renders both triangles\n- No indexing - each triangle uses 3 unique vertices","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.html#module-framework-adaptation-notes"},{"type":"module","title":"Original Tutorial Exercise - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1","doc":"**Exercise 1**: Try to draw 2 triangles next to each other using glDrawArrays\nby adding more vertices to your data.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.html#module-original-tutorial-exercise"},{"type":"module","title":"Solution Concepts Demonstrated - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1","doc":"1. **Multiple Primitives**: Drawing 2 triangles with one draw call\n2. **Vertex Array Layout**: 6 vertices arranged as 2 separate triangles\n3. **Spatial Positioning**: Placing triangles side by side in NDC space\n4. **Draw Call Efficiency**: Single glDrawArrays for multiple primitives\n5. **Vertex Ordering**: Understanding how vertices form triangles","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.html#module-solution-concepts-demonstrated"},{"type":"module","title":"Key Learning Points - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1","doc":"- How to structure vertex data for multiple primitives\n- The relationship between vertex count and triangle count\n- Positioning geometry in normalized device coordinates\n- When to use glDrawArrays vs glDrawElements\n- Understanding primitive assembly from vertex streams","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.html#module-key-learning-points"},{"type":"module","title":"Triangle Geometry - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1","doc":"Two triangles positioned side by side:\n```\nLeft Triangle:     Right Triangle:\n    /\\                 /\\\n   /  \\               /  \\\n  /____\\             /____\\\n```\n\n6 vertices total: 3 for left triangle + 3 for right triangle\nNo vertex sharing (unlike indexed rendering)","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.html#module-triangle-geometry"},{"type":"module","title":"Difference from Previous Examples - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1","doc":"- **2.1 Hello Triangle**: 1 triangle, 3 vertices\n- **2.2 Hello Triangle Indexed**: 1 rectangle (2 triangles), 4 vertices + indices\n- **2.3 Exercise 1**: 2 triangles, 6 vertices (no sharing)","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.html#module-difference-from-previous-examples"},{"type":"module","title":"Usage - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1","doc":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.run_example()\n\nPress ENTER to exit the example.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.html#module-usage"},{"type":"function","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.run_example/0","doc":"","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.html#run_example/0"},{"type":"module","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2","doc":"LearnOpenGL 2.4 - Hello Triangle Exercise 2 (Rectangle with EBO)\n\nThis example demonstrates creating two triangles using Element Buffer Objects.\nIt solves the second exercise from the Hello Triangle tutorial.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.html"},{"type":"module","title":"Original C++ Source - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2","doc":"This example is based on the original LearnOpenGL C++ tutorial:","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.html#module-original-c-source"},{"type":"module","title":"Framework Adaptation Notes - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2","doc":"In the original LearnOpenGL C++ tutorial, this exercise asks you to create two triangles\nusing a single VAO and VBO, with an Element Buffer Object (EBO) to avoid vertex duplication.\n\nEAGL's framework maintains the same approach:\n- Single VAO/VBO/EBO for efficient vertex sharing\n- glDrawElements for indexed rendering\n- 4 vertices create 2 triangles through clever indexing","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.html#module-framework-adaptation-notes"},{"type":"module","title":"Original Tutorial Exercise - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2","doc":"**Exercise 2**: Now create the same 2 triangles using an EBO so there are only 4 vertices\nin total instead of 6. This is a solution to the previous exercise using indices.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.html#module-original-tutorial-exercise"},{"type":"module","title":"Solution Concepts Demonstrated - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2","doc":"1. **Element Buffer Objects (EBO)**: Storing indices for vertex reuse\n2. **Vertex Sharing**: 4 vertices used to create 2 triangles\n3. **Indexed Rendering**: glDrawElements with index buffer\n4. **Memory Efficiency**: Reducing vertex data through sharing\n5. **Rectangle Formation**: Two triangles forming a quad","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.html#module-solution-concepts-demonstrated"},{"type":"module","title":"Key Learning Points - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2","doc":"- How EBOs enable vertex sharing between primitives\n- The efficiency difference between indexed and non-indexed rendering\n- Understanding triangle winding order and connectivity\n- When indexed rendering provides the most benefit\n- The relationship between vertex count and primitive count","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.html#module-key-learning-points"},{"type":"module","title":"Rectangle Geometry - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2","doc":"Two triangles sharing vertices to form a rectangle:\n```\n3 ---- 2\n|    / |\n|   /  |\n|  /   |\n| /    |\n0 ---- 1\n```\n\n4 vertices total, 6 indices: [0,1,3, 1,2,3]\nTriangle 1: vertices 0,1,3 | Triangle 2: vertices 1,2,3","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.html#module-rectangle-geometry"},{"type":"module","title":"Difference from Previous Examples - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2","doc":"- **2.3 Exercise 1**: 2 triangles, 6 vertices (no sharing)\n- **2.4 Exercise 2**: 2 triangles, 4 vertices + indices (vertex sharing)","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.html#module-difference-from-previous-examples"},{"type":"module","title":"Usage - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2","doc":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.run_example()\n\nPress ENTER to exit the example.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.html#module-usage"},{"type":"function","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.run_example/0","doc":"","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.html#run_example/0"},{"type":"module","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3","doc":"LearnOpenGL 2.5 - Hello Triangle Exercise 3 (Multiple Shader Programs)\n\nThis example demonstrates using multiple shader programs to render different colored triangles.\nIt solves the third exercise from the Hello Triangle tutorial.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.html"},{"type":"module","title":"Original C++ Source - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3","doc":"This example is based on the original LearnOpenGL C++ tutorial:","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.html#module-original-c-source"},{"type":"module","title":"Framework Adaptation Notes - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3","doc":"In the original LearnOpenGL C++ tutorial, this exercise asks you to create two triangles\nthat render with different colors by using different fragment shaders.\n\nEAGL's framework maintains the same approach:\n- Two separate VAO/VBO pairs for independent geometry\n- Shared vertex shader between both programs\n- Different fragment shaders for different colors\n- Multiple draw calls with different shader programs","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.html#module-framework-adaptation-notes"},{"type":"module","title":"Original Tutorial Exercise - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3","doc":"**Exercise 3**: Create two shader programs where the second program uses a different\nfragment shader that outputs the color yellow; draw both triangles again where one\noutputs the color orange and the other outputs the color yellow.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.html#module-original-tutorial-exercise"},{"type":"module","title":"Solution Concepts Demonstrated - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3","doc":"1. **Multiple Shader Programs**: Creating and managing separate programs\n2. **Shader Reuse**: Same vertex shader used in both programs\n3. **Fragment Shader Variants**: Different colors from different shaders\n4. **Separate Geometry**: Independent VAO/VBO pairs\n5. **Multi-Pass Rendering**: Multiple draw calls with different programs","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.html#module-solution-concepts-demonstrated"},{"type":"module","title":"Key Learning Points - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3","doc":"- How to create and manage multiple shader programs\n- Sharing shaders between different programs\n- The relationship between shader programs and rendering state\n- When to use separate geometry vs shared geometry\n- Understanding the cost of shader program switches","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.html#module-key-learning-points"},{"type":"module","title":"Triangle Geometry and Colors - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3","doc":"Two separate triangles with different colors:\n```\nLeft Triangle (Orange)    Right Triangle (Yellow)\n      /\\                       /\\\n     /  \\                     /  \\\n    /____\\                   /____\\\n```\n\n- Left triangle: Orange fragment shader\n- Right triangle: Yellow fragment shader\n- Same vertex shader for both triangles","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.html#module-triangle-geometry-and-colors"},{"type":"module","title":"Difference from Previous Examples - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3","doc":"- **2.3 Exercise 1**: 2 triangles, 1 shader program, same color\n- **2.4 Exercise 2**: 2 triangles (rectangle), 1 shader program, same color\n- **2.5 Exercise 3**: 2 triangles, 2 shader programs, different colors","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.html#module-difference-from-previous-examples"},{"type":"module","title":"Usage - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3","doc":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.run_example()\n\nPress ENTER to exit the example.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.html#module-usage"},{"type":"function","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.run_example/0","doc":"","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.html#run_example/0"},{"type":"module","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed","doc":"LearnOpenGL 2.2 - Hello Triangle Indexed (Element Buffer Objects)\n\nThis example demonstrates Element Buffer Objects (EBO) for efficient indexed rendering.\nIt shows how to draw a rectangle using two triangles with shared vertices.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed.html"},{"type":"module","title":"Original C++ Source - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed","doc":"This example is based on the original LearnOpenGL C++ tutorial:","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed.html#module-original-c-source"},{"type":"module","title":"Framework Adaptation Notes - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed","doc":"In the original LearnOpenGL C++ tutorial, this example introduces Element Buffer Objects (EBOs)\nas a way to avoid vertex duplication when drawing complex shapes.\n\nEAGL's framework maintains the same concepts while providing helper functions:\n- EBO creation and binding are handled by EAGL.Buffer functions\n- The core concept of indexed rendering remains unchanged\n- glDrawElements vs glDrawArrays distinction is preserved","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed.html#module-framework-adaptation-notes"},{"type":"module","title":"Original Tutorial Concepts Demonstrated - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed","doc":"1. **Element Buffer Objects (EBO)**: Storing vertex indices for reuse\n2. **Indexed Rendering**: Drawing with glDrawElements instead of glDrawArrays\n3. **Vertex Sharing**: Using 4 vertices to draw 2 triangles (6 vertices worth)\n4. **Memory Efficiency**: Avoiding duplicate vertex data\n5. **Triangle Assembly**: How indices define triangle connectivity","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed.html#module-original-tutorial-concepts-demonstrated"},{"type":"module","title":"Key Learning Points - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed","doc":"- Understanding indexed vs non-indexed rendering\n- Memory efficiency through vertex sharing\n- The relationship between vertices and indices\n- When to use EBOs vs simple vertex arrays\n- Triangle winding order and face culling implications","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed.html#module-key-learning-points"},{"type":"module","title":"Rectangle Geometry - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed","doc":"The rectangle is defined by 4 vertices with 6 indices (2 triangles):\n```\n3 ---- 2\n|    / |\n|   /  |\n|  /   |\n| /    |\n0 ---- 1\n```\n\nVertices: 4 unique positions\nIndices: [0,1,3, 1,2,3] (2 triangles sharing vertices 0, 1, and 3)","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed.html#module-rectangle-geometry"},{"type":"module","title":"Difference from Previous Examples - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed","doc":"- **2.1 Hello Triangle**: 3 vertices, glDrawArrays (no sharing)\n- **2.2 Hello Triangle Indexed**: 4 vertices + indices, glDrawElements (vertex sharing)","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed.html#module-difference-from-previous-examples"},{"type":"module","title":"Usage - EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed","doc":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed.run_example()\n\nPress ENTER to exit the example.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed.html#module-usage"},{"type":"function","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed.run_example/0","doc":"","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleIndexed.html#run_example/0"},{"type":"module","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow","doc":"LearnOpenGL 1.1 - Hello Window\n\nThis example demonstrates basic window creation and OpenGL context setup.\nIt corresponds to the first rendering example in the LearnOpenGL tutorial series.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow.html"},{"type":"module","title":"Original C++ Source - EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow","doc":"This example is based on the original LearnOpenGL C++ tutorial:","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow.html#module-original-c-source"},{"type":"module","title":"Framework Adaptation Notes - EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow","doc":"In the original LearnOpenGL C++ tutorial, this example shows a completely black window\nbecause no clearing is performed in the render loop. However, EAGL's Window framework\nautomatically handles basic OpenGL setup including an initial clear for clean state.\n\nTo maintain the pedagogical value while working within EAGL's design:\n- We set the clear color to black (0.0, 0.0, 0.0) to match the original example\n- The framework handles the actual clearing, but we demonstrate the concept\n- Comments explain what would happen without framework assistance","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow.html#module-framework-adaptation-notes"},{"type":"module","title":"Original Tutorial Concepts Demonstrated - EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow","doc":"1. **Window Creation**: EAGL.Window handles GLFW setup and OpenGL context creation\n2. **Render Loop**: The framework manages the main loop and buffer swapping\n3. **Basic Rendering**: Shows the foundation for all subsequent examples\n4. **Input Handling**: ENTER key to exit (handled by framework)","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow.html#module-original-tutorial-concepts-demonstrated"},{"type":"module","title":"Key Learning Points - EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow","doc":"- Understanding the render loop concept\n- OpenGL context and window management\n- The importance of clearing buffers\n- Foundation for more complex rendering","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow.html#module-key-learning-points"},{"type":"module","title":"Usage - EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow","doc":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow.run_example()\n\nPress ENTER to exit the example.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow.html#module-usage"},{"type":"function","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow.run_example/0","doc":"","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindow.html#run_example/0"},{"type":"module","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear","doc":"LearnOpenGL 1.2 - Hello Window Clear\n\nThis example demonstrates setting a custom clear color for the OpenGL framebuffer.\nIt builds upon the 1.1 Hello Window example by showing how to control the background color.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear.html"},{"type":"module","title":"Original C++ Source - EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear","doc":"This example is based on the original LearnOpenGL C++ tutorial:","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear.html#module-original-c-source"},{"type":"module","title":"Framework Adaptation Notes - EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear","doc":"In the original LearnOpenGL C++ tutorial, this example introduces the concept of:\n- `glClearColor()` - setting the clear color state\n- `glClear(GL_COLOR_BUFFER_BIT)` - actually clearing the buffer\n\nEAGL's Window framework automatically handles clearing for clean state, but this example\ndemonstrates the pedagogical concepts by:\n- Explicitly calling `glClearColor()` to set a custom color\n- Showing the difference between state-setting and state-using functions\n- Explaining the OpenGL state machine concept","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear.html#module-framework-adaptation-notes"},{"type":"module","title":"Original Tutorial Concepts Demonstrated - EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear","doc":"1. **OpenGL State Machine**: `glClearColor` sets state, `glClear` uses that state\n2. **Color Buffer Clearing**: Essential for preventing visual artifacts\n3. **RGBA Color Values**: Understanding the 0.0-1.0 range for color components\n4. **Render Loop Integration**: Where clearing fits in the rendering pipeline","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear.html#module-original-tutorial-concepts-demonstrated"},{"type":"module","title":"Key Learning Points - EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear","doc":"- Understanding OpenGL's state-setting vs state-using functions\n- The importance of clearing buffers each frame\n- How color values work in OpenGL (0.0-1.0 range)\n- The difference between this and 1.1 (black vs colored background)","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear.html#module-key-learning-points"},{"type":"module","title":"Usage - EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear","doc":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear.run_example()\n\nPress ENTER to exit the example.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear.html#module-usage"},{"type":"function","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear.run_example/0","doc":"","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloWindowClear.html#run_example/0"},{"type":"module","title":"EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform","doc":"LearnOpenGL 3.1 - Shaders Uniform\n\nThis example demonstrates uniform variables in shaders - global variables that remain constant\nacross all vertices in a draw call but can be updated between draw calls.\nIt corresponds to the Shaders Uniform tutorial in the LearnOpenGL series.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform.html"},{"type":"module","title":"Original C++ Source - EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform","doc":"This example is based on the original LearnOpenGL C++ tutorial:","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform.html#module-original-c-source"},{"type":"module","title":"Framework Adaptation Notes - EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform","doc":"In the original LearnOpenGL C++ tutorial, this example introduces uniform variables:\n- How to declare uniforms in GLSL\n- How to get uniform locations from the application\n- How to update uniform values using glUniform* functions\n- Creating animated effects by updating uniforms per frame\n\nEAGL's framework preserves all these concepts while providing convenience functions:\n- EAGL.Shader.set_uniform() handles the glGetUniformLocation + glUniform* pattern\n- Error checking and type detection are automated\n- The core OpenGL uniform concepts remain unchanged and visible","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform.html#module-framework-adaptation-notes"},{"type":"module","title":"Key Difference: Animation Timing - EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform","doc":"**Original LearnOpenGL approach:** Time calculation happens directly in the render loop:\n```c++\nwhile (!glfwWindowShouldClose(window)) {\n    float timeValue = glfwGetTime();  // Get time in render loop\n    float greenValue = sin(timeValue) / 2.0f + 0.5f;\n    glUniform4f(vertexColorLocation, 0.0f, greenValue, 0.0f, 1.0f);\n    // ... render\n}\n```\n\n**EAGL approach:** Uses the tick handler pattern for clean separation of concerns:\n- `handle_event(:tick, state)` updates time state each frame\n- `render/3` uses the current time state for animation\n- This separates state management from rendering logic","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform.html#module-key-difference-animation-timing"},{"type":"module","title":"Original Tutorial Concepts Demonstrated - EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform","doc":"1. **Uniform Declaration**: Declaring `uniform vec4 ourColor` in the fragment shader\n2. **Uniform Location**: Getting the uniform location using `glGetUniformLocation`\n3. **Uniform Updates**: Using `glUniform4f` to update the uniform value\n4. **Animation**: Updating the uniform each frame using `sin(time)` for color cycling\n5. **Shader Communication**: Passing data from application to shader via uniforms","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform.html#module-original-tutorial-concepts-demonstrated"},{"type":"module","title":"Key Learning Points - EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform","doc":"- Understanding the difference between attributes and uniforms\n- Uniforms are global variables that stay constant per draw call\n- Uniforms can be updated between draw calls to create dynamic effects\n- Time-based animation using mathematical functions\n- The OpenGL uniform system and how it bridges CPU and GPU","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform.html#module-key-learning-points"},{"type":"module","title":"Color Animation - EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform","doc":"The triangle color cycles through a green color animation:\n- Color varies from dark green (0.0) to bright green (1.0)\n- Uses `sin(time)` to create smooth oscillation\n- Red and blue components remain at 0.0\n- Alpha remains at 1.0 (fully opaque)","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform.html#module-color-animation"},{"type":"module","title":"Difference from Previous Examples - EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform","doc":"- **2.1 Hello Triangle**: Static orange triangle with hardcoded fragment color\n- **3.1 Shaders Uniform**: Dynamic color animation using uniform variables","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform.html#module-difference-from-previous-examples"},{"type":"module","title":"Usage - EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform","doc":"EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform.run_example()\n\nPress ENTER to exit the example.","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform.html#module-usage"},{"type":"function","title":"EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform.run_example/0","doc":"","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.ShadersUniform.html#run_example/0"},{"type":"extras","title":"README","doc":"EAGL \n   \n   \n    Make it EAsier to work \n    with OpenGL in Elixir.","ref":"readme.html"},{"type":"extras","title":"Overview - README","doc":"Most examples of working with OpenGL are written in C++ or C# (Unity). The purpose of the EAGL library is to:\n- Make it easier to translate OpenGL tutorials and examples from resources like [Learn OpenGL](https://learnopengl.com) into Elixir. \n- Provide basic helper functions to bridge the gap between idiomatic Elixir and OpenGL's state machine, using the Wings 3D Erlang source as a guide.\n- Enable other libraries and apps to build on this one - e.g. there should be Unity-like tool for the BEAM.\n\nThe following are non-goals:\n- Wrapping of the Erlang wx library\n- A Shader DSL\n- A UI layout/component library\n- 3D mesh modelling (leave that to Wings 3D, Blender etc)","ref":"readme.html#overview"},{"type":"extras","title":"Quick Start - README","doc":"```elixir\n# Add to mix.exs\n{:eagl, \"~> 0.1.0\"}\n```\n\nEAGL includes several examples to demonstrate its capabilities. Use the unified examples runner:\n\n```\n./priv/scripts/run_examples\n═══════════════════════════════════════════════════════════════\n                    EAGL Examples Menu\n═══════════════════════════════════════════════════════════════\n\n 1) Math Example\n    Comprehensive example demonstrating all EAGL.Math functionality\n\n 2) Teapot Example\n    Draw a 3D teapot with Phong shading\n\nLearnOpenGL Examples:\n\n  1. Getting Started:\n     3) 1.1 Hello Window\n        Basic window creation - Foundation of all OpenGL applications\n\n     4) 1.2 Hello Window Clear\n        Custom clear colors - Understanding OpenGL's state machine\n\n     5) 2.1 Hello Triangle\n        Your first triangle - Basic VAO/VBO and shader fundamentals\n\n     6) 2.2 Hello Triangle Indexed\n        Element Buffer Objects (EBO) - Basic indexed rectangle rendering\n\n     7) 2.3 Hello Triangle Exercise 1\n        Two Triangles Side by Side - Using glDrawArrays with 6 vertices\n\n     8) 2.4 Hello Triangle Exercise 2\n        Element Buffer Objects (EBO) - Rectangle using shared vertices\n\n     9) 2.5 Hello Triangle Exercise 3\n        Multiple Shader Programs - Two triangles with different colors\n\n     ...\n\n═══════════════════════════════════════════════════════════════\nEnter example number (1-9), 'q' to quit, or 'r' to refresh:\n>\n```","ref":"readme.html#quick-start"},{"type":"extras","title":"Usage - README","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Math Operations - README","doc":"```elixir\nimport EAGL.Math\n\n# Vector operations\nposition = vec3(1.0, 2.0, 3.0)\ndirection = vec3(0.0, 1.0, 0.0) \nresult = vec_add(position, direction)\nlength = vec_length(position)\n\n# Matrix transformations\nmodel = mat4_translate(vec3(5.0, 0.0, 0.0))\nview = mat4_look_at(\n  vec3(0.0, 0.0, 5.0),  # eye\n  vec3(0.0, 0.0, 0.0),  # target\n  vec3(0.0, 1.0, 0.0)   # up\n)\nprojection = mat4_perspective(radians(45.0), 16.0/9.0, 0.1, 100.0)\n```\n\nEAGL provides a comprehensive 3D math library based on GLM supporting:\n\n- **Vectors**: 2D, 3D, 4D vector operations with constructor macros\n- **Matrices**: 2x2, 3x3, 4x4 matrix operations with transformation functions\n- **Quaternions**: Rotation representation, SLERP, and conversion functions\n- **Utilities**: Trigonometry, interpolation, clamping, and geometric functions\n- **OpenGL Integration**: All functions work with the tuple-in-list format required by Erlang's OpenGL bindings","ref":"readme.html#math-operations"},{"type":"extras","title":"Shader Management - README","doc":"```elixir\nimport EAGL.Shader\n\n# Compile and link shaders\n{:ok, vertex} = create_shader(@gl_vertex_shader, \"vertex.glsl\")\n{:ok, fragment} = create_shader(@gl_fragment_shader, \"fragment.glsl\")\n{:ok, program} = create_attach_link([vertex, fragment])\n\n# Set uniforms with automatic type detection\nset_uniform(program, \"model_matrix\", model_matrix)\nset_uniform(program, \"light_position\", vec3(10.0, 10.0, 5.0))\nset_uniform(program, \"time\", :erlang.monotonic_time(:millisecond))\n\n# Or set multiple uniforms at once\nset_uniforms(program, [\n  model: model_matrix,\n  view: view_matrix,\n  projection: projection_matrix,\n  light_position: vec3(10.0, 10.0, 5.0),\n  light_color: vec3(1.0, 1.0, 1.0)\n])\n```\n\nThe uniform helpers (from Wings3D) automatically detect the type of EAGL.Math values, eliminating the need to manually unpack vectors or handle different uniform types:\n\n- `vec2/3/4` → `glUniform2f/3f/4f`\n- `mat2/3/4` → `glUniformMatrix2fv/3fv/4fv` \n- Numbers → `glUniform1f/1i`\n- Booleans → `glUniform1i` (0 or 1)","ref":"readme.html#shader-management"},{"type":"extras","title":"Model Loading - README","doc":"```elixir\nimport EAGL.Model\n\n# Load OBJ file (with automatic normal generation if missing)\n{:ok, model} = load_model_to_vao(\"teapot.obj\")\n\n# Render the model\n:gl.bindVertexArray(model.vao)\n:gl.drawElements(@gl_triangles, model.vertex_count, @gl_unsigned_int, 0)\n```","ref":"readme.html#model-loading"},{"type":"extras","title":"Buffer Management - README","doc":"```elixir\nimport EAGL.Buffer\n\n# Create simple position-only VAO/VBO (convenience function)\nvertices = [-0.5, -0.5, 0.0, 0.5, -0.5, 0.0, 0.0, 0.5, 0.0]\n{vao, vbo} = create_position_array(vertices)\n\n# Or create with custom attributes (general function)\n{vao, vbo} = create_vertex_array(vertices, [\n  {0, 3, @gl_float, @gl_false, 0, 0}  # position at location 0\n])\n\n# Clean up\ndelete_vertex_array(vao, vbo)\n```","ref":"readme.html#buffer-management"},{"type":"extras","title":"Error Handling - README","doc":"```elixir\nimport EAGL.Error\n\n# Check for OpenGL errors with context\ncheck(\"After buffer creation\")  # Returns :ok or {:error, message}\n\n# Get human-readable error string for error code\nerror_string(1280)  # \"GL_INVALID_ENUM\"\n\n# Check and raise on error (useful for debugging)\ncheck!(\"Critical operation\")  # Raises RuntimeError if error found\n```","ref":"readme.html#error-handling"},{"type":"extras","title":"Window Creation - README","doc":"EAGL provides flexible window creation with a clean, options-based API:\n\n- **Default Size**: 1024x768 pixels (can be customized with `size:` option)\n- **2D Rendering** (default): No depth buffer, suitable for triangles, sprites, UI elements\n- **3D Rendering**: Enables depth testing and depth buffer for proper 3D scene rendering\n- **Automatic ENTER Handling**: Optional ENTER key handling for simple examples and tutorials\n\n```elixir\ndefmodule MyApp do\n  use EAGL.Window\n  import EAGL.Shader\n  import EAGL.Math\n\n  def run_example do\n    # For 2D rendering (triangles, sprites, UI) - uses default 1024x768 size\n    EAGL.Window.run(__MODULE__, \"My 2D OpenGL App\")\n    \n    # For 3D rendering (models, scenes with depth)\n    EAGL.Window.run(__MODULE__, \"My 3D OpenGL App\", depth_testing: true)\n    \n    # For tutorials/examples with automatic ENTER key handling\n    EAGL.Window.run(__MODULE__, \"Tutorial Example\", return_to_exit: true)\n    \n    # Custom window size and options\n    EAGL.Window.run(__MODULE__, \"Custom Size App\", size: {1280, 720}, depth_testing: true, return_to_exit: true)\n  end\n\n  @impl true\n  def setup do\n    # Initialize shaders, load models, etc.\n    {:ok, initial_state}\n  end\n\n  @impl true\n  def render(width, height, state) do\n    # Your render function should handle clearing the screen\n    :gl.clearColor(0.2, 0.3, 0.3, 1.0)\n    \n    # For 2D rendering (depth_testing: false, default)\n    :gl.clear(@gl_color_buffer_bit)\n    \n    # For 3D rendering (depth_testing: true)\n    # :gl.clear(@gl_color_buffer_bit ||| @gl_depth_buffer_bit)\n    \n    # Render your content here\n    :ok\n  end\n\n  @impl true\n  def cleanup(state) do\n    # Clean up resources\n    :ok\n  end\nend\n```","ref":"readme.html#window-creation"},{"type":"extras","title":"Requirements - README","doc":"- **Elixir**: 1.14 or later\n- **Erlang/OTP**: 25 or later (with wx support - included in standard distributions)\n- **OpenGL**: 3.3 or later (for modern shader support)","ref":"readme.html#requirements"},{"type":"extras","title":"Platform-specific Notes - README","doc":"#### All Platforms\nEAGL uses Erlang's built-in `wx` module for windowing, which is included with standard Erlang/OTP installations. No additional GUI libraries need to be installed.\n\n#### Linux\nEnsure you have OpenGL drivers installed:\n```bash\n# Ubuntu/Debian\nsudo apt-get install libgl1-mesa-dev libglu1-mesa-dev\n\n# Fedora/RHEL\nsudo dnf install mesa-libGL-devel mesa-libGLU-devel\n```\n\n#### macOS\nOpenGL is included with macOS. No additional setup required.\n\n**Note**: EAGL automatically detects macOS and enables forward compatibility for OpenGL 3.0+ contexts, which is required by Apple's OpenGL implementation. This matches the behavior of the `#ifdef __APPLE__` code commonly found in OpenGL tutorials.\n\n#### Windows  \nOpenGL is typically available through graphics drivers. If you encounter issues, ensure your graphics drivers are up to date.","ref":"readme.html#platform-specific-notes"},{"type":"extras","title":"Installation - README","doc":"1. Clone the repository:\n   ```bash\n   git clone https://github.com/yourusername/eagl.git\n   cd eagl\n   ```\n\n2. Install dependencies:\n   ```bash\n   mix deps.get\n   ```\n\n3. Compile the project:\n   ```bash\n   mix compile\n   ```\n\n4. Run tests to verify everything works:\n   ```bash\n   mix test\n   ```\n\n5. Try the examples:\n   ```bash\n   ./priv/scripts/run_examples\n   ```","ref":"readme.html#installation"},{"type":"extras","title":"Project Structure - README","doc":"```\nlib/\n├── eagl/                   # Core EAGL modules\n│   ├── buffer.ex           # VAO/VBO helper functions\n│   ├── const.ex            # OpenGL constants\n│   ├── error.ex            # Error checking and reporting\n│   ├── math.ex             # GLM-style math library\n│   ├── model.ex            # 3D model management\n│   ├── obj_loader.ex       # Wavefront OBJ parser\n│   ├── shader.ex           # Shader compilation\n│   ├── window.ex           # Window management\n│   └── window_behaviour.ex # Window callback behavior\n├── examples/               # Example applications\n│   ├── math_example.ex     # Math library demonstrations\n│   ├── teapot_example.ex   # 3D teapot rendering\n│   └── learnopengl/        # LearnOpenGL tutorial ports\n└── wx/                     # wxWidgets constants\ntest/\n├── eagl/                   # Unit tests for EAGL modules\n└── eagl_test.exs           # Integration tests\npriv/\n├── models/                 # 3D model files (.obj)\n├── scripts/                # Convenience scripts\n│   └── run_examples        # Unified examples runner\n└── shaders/                # GLSL shader files\n    └── learnopengl/        # LearnOpenGL tutorial shaders\n```","ref":"readme.html#project-structure"},{"type":"extras","title":"Features - README","doc":"- ✅ **Shader Management**: Automatic compilation, linking, and error reporting\n- ✅ **3D Model Loading**: Wavefront OBJ format with normals and texture coordinates\n- ✅ **Math Library**: GLM-compatible vectors, matrices, quaternions with full OpenGL integration\n- ✅ **Buffer Helpers**: Wings3D-inspired VAO/VBO management functions\n- ✅ **Error Handling**: Comprehensive OpenGL error checking and reporting\n- ✅ **Window Management**: Cross-platform window creation with wxWidgets\n- ✅ **Event Handling**: Resize, close, and paint events\n- ✅ **Resource Cleanup**: Automatic cleanup of OpenGL resources\n- ✅ **LearnOpenGL Examples**: Direct ports of popular OpenGL tutorials\n- ✅ **Testing**: Full test suite with OpenGL context mocking","ref":"readme.html#features"},{"type":"extras","title":"Roadmap - README","doc":"The current focus is to:\n\n- [ ] Port all the Learning OpenGL examples, adding helper functions when necessary\n- [ ] Load common model types like GLTF\n\nAnd in future:\n\n- [ ] Be able to apply post-processing effects\n- [ ] More extensive camera/lighting/material helpers\n- [ ] Access to a physics engine\n- [ ] Built-in GPU profiling tools","ref":"readme.html#roadmap"},{"type":"extras","title":"Community Contributions Welcome - README","doc":"- Documentation improvements and tutorials\n- Additional LearnOpenGL tutorial ports\n- Platform-specific optimizations\n- Example applications and demos","ref":"readme.html#community-contributions-welcome"},{"type":"extras","title":"Troubleshooting - README","doc":"","ref":"readme.html#troubleshooting"},{"type":"extras","title":"Development Issues - README","doc":"Most of these are obvious, but it helps AI assistants remember how to get around the project.\n\n#### Interactive Examples Hanging\nExamples require user interaction (ESC key to exit). When running tests:\n```bash\n# Run only unit tests, exclude interactive examples\nmix test test/eagl/ --exclude interactive\n\n# Or set a timeout for interactive tests\nmix test --timeout 10000\n```\n\n#### IEx Session Conflicts\nIf stuck in an IEx session when trying to run mix commands:\n```bash\n# Press 'a' to abort the IEx session, then run your command\n# Example: after getting stuck, press 'a' then run:\nmix compile\n```\n\n#### Test Timeouts\nInteractive examples wait for ESC key presses and will timeout in CI:\n- Use `@tag :interactive` for examples that require user input\n- CI automatically excludes these tests\n- Local development can run them individually\n\n#### Examples Runner Interactive Input\nThe examples runner script requires user input and cannot be automated:\n```bash\n# This will hang waiting for user input:\n./priv/scripts/run_examples\n\n# To test examples programmatically, run them directly:\nmix run -e \"EAGL.Examples.Math.run_example()\"\ntimeout 5s mix run -e \"EAGL.Examples.Teapot.run_example()\"\n```","ref":"readme.html#development-issues"},{"type":"extras","title":"Contributing - README","doc":"1. Fork the repository\n2. Create a feature branch (`git checkout -b feature/amazing-feature`)\n3. Commit your changes (`git commit -m 'Add amazing feature'`)\n4. Push to the branch (`git push origin feature/amazing-feature`)\n5. Open a Pull Request","ref":"readme.html#contributing"},{"type":"extras","title":"License - README","doc":"This project is licensed under the MIT License - see the [LICENSE](LICENSE) file for details.","ref":"readme.html#license"},{"type":"extras","title":"Acknowledgments - README","doc":"- [Learn OpenGL](https://learnopengl.com) for excellent OpenGL tutorials\n- [Wings3D](https://wings3d.com) for inspiration and helper function patterns - the name EAGL(e) is a tip of the hat to this project\n- The Erlang/OTP team for wxWidgets bindings\n- The Elixir community for inspiration and support, particularly the [Elixir Sydney/Australia User Group](https://https://elixir.sydney)\n- [Cursor](https://cursor.com) and Claude Sonnet for giving me the patience to get to running code and port the Learning OpenGL examples","ref":"readme.html#acknowledgments"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2025 Robin Hiliard\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}